#
# HaloDemoTrainer.py
#
# Created by nil, thanks to modfox for finding me the warthog position addresses
# Copyright (c) 2008. All rights reserved.

#you need to include this
from VirtualMemory import *
#although this script in particular doesn't use writeLog() from Debug, you'll almost always want to include this
from Debug import *
#I'm using trig functions from math module
import math

#Basic script attributes
WINDOW_TITLE = "Circular warthog"
DESCRIPTION = "The mathematical warthog grapher! Drawing a circle with the parametric equation x = cos(t), z = sin(t). This must be played on Slayer."
#This is a time interval in seconds, indicating how often our script's execute function is called when it's running
EXECUTION_TIME_INTERVAL = 0.03

#my halo demo constants
WARTHOG_X_POSITION_ADDRESS = 0x4BB26798
WARTHOG_Z_POSITION_ADDRESS = 0x4BB267A0
WARTHOG_CURVE_Z_ORIGIN_OFFSET = 5.0
WARTHOG_CURVE_ALTITUDE = 4.0

#my global variables
warthogBaseX = 0
warthogBaseZ = 0

#this function is called every EXECUTION_TIME_INTERVAL seconds, as long as the script is running
def execute(timeElapsed):
	#I need to declare these as globals if I want to use them from inside this function
	global warthogBaseX
	global warthogBaseZ
	
	#timeElapsed will be 0 right when the user hits 'Start' (the first time this function is called)
	if timeElapsed == 0:
		#the x and z values of where the warthog orginally is at the beginning of this script are going to be stored in these base variables
		warthogBaseX = readFloat(WARTHOG_X_POSITION_ADDRESS)
		# I want baseZ to be a little bit higher than where the warthog currently is, which is what
		# WARTHOG_CURVE_Z_ORIGIN_OFFSET is used for
		warthogBaseZ = readFloat(WARTHOG_Z_POSITION_ADDRESS) + WARTHOG_CURVE_Z_ORIGIN_OFFSET
	else:
		#use basic trig to create a parametric curve with x = cos(t) and z = sin(t) where t is timeElapsed
		#this parametric formula is simply just a circle
		#so, this makes the warthog go move in a circle
		writeFloat(WARTHOG_X_POSITION_ADDRESS, warthogBaseX + math.cos(timeElapsed) * WARTHOG_CURVE_ALTITUDE)
		writeFloat(WARTHOG_Z_POSITION_ADDRESS, warthogBaseZ + math.sin(timeElapsed) * WARTHOG_CURVE_ALTITUDE)

#this is called when the either the user hits stop or the script stops unexpectedly
def finish(timeElapsed, forcedShutDown):
	#this is where we clean up our mess. Place the warthog back where it originally was before the script was executed.
	writeFloat(WARTHOG_X_POSITION_ADDRESS, warthogBaseX)
	writeFloat(WARTHOG_Z_POSITION_ADDRESS, warthogBaseZ - WARTHOG_CURVE_Z_ORIGIN_OFFSET)